/*****************************************************************************
 *	aisa22s.c
 *
 *	aISA-P22
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#define	STRICT
#include	<windows.h>
#include	<tchar.h>
#include	"aisa22w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP22[] = _T("aISA-P22");
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  InValue;
	AISA22RESOURCE ri;				// \[X

//-----------------	 aisa22.dll ̎gp錾 --------------------------------
	if (Aisa22wDllOpen() == FALSE) {
		ErrorMessage(AISA22_SLOT_AUTO);
		return 1;			// aisa22.dll ̃[hɎs܂
	}

//--------------------	o[Wԍ\	----------------------------------
	// aISA-P22 DLL,Driver̃o[Wԍ擾
	if (Aisa22wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(AISA22_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("GetVersion\n") _T("DLL Version: %08lxh\n")
							_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);

//-----------------------  aISA-P22̎gp錾	 ---------------------------

	wLogSlot = AISA22_SLOT_AUTO;			// gp̃foCXT܂B
	bResult = Aisa22wCreate( &wLogSlot );
				// wLogSlot -- ꍇA̎̃foCXi[܂B
	if (bResult == FALSE) {
		ErrorMessage(AISA22_SLOT_AUTO);		// foCX܂B
		return 1;
	}
	wsprintf(szbuf, _T("aISA-P22 Created\n\n") _T("LogSlot: %2d\n"), wLogSlot);
	ResultMessage(szbuf);

//------------------------------  \[X擾  -------------------------
	if (Aisa22wGetResource(wLogSlot, &ri) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Board Name: %s\n") _T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n") ,
					szP22, ri.dwIOPortLength[0], ri.dwIOPortBase[0],
					ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1 );
	ResultMessage(szbuf);

//---------------------	 Port0 f[^ǂݍ	 -------------------------
	InValue = (BYTE)0x00;

	if (Aisa22wInPort(wLogSlot, AISA22_PORT_0, &InValue) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Port0f[^\n")
					_T("Port0 In Data: %02xh"), InValue);
	ResultMessage(szbuf);

//-------------------  aISA-P22̎gpJ	 -------------------------------
	if (Aisa22wClose(wLogSlot) == FALSE) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aISA-P22 Closed"));

//----------------------  aisa22.dll ̎gpJ  -------------------------
	if (Aisa22wDllClose() == FALSE) {
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"),
										szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa22.dll ̃A[hɎs܂B
	}
	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa22wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AISA22_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"), GetLastError());
			break;

		case AISA22_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P22 error\n\n")
							_T("Error code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
